const {
    JSDOM
} = require("jsdom");
const fs = require("fs");
const converter = require("./showdown")(2);

let folder = __dirname + "/../";
console.log("Refreshing blog sub-sites...");

fs.readFile(folder + "index.html", function (_, data) {
    // this can probably be done a lot easier but regex is hard ok
    var template = data.toString().replace(/<!-- ?NOBLOG ?-->([^](?!<!-- ?NOBLOG ?-->))*<!-- ?\/NOBLOG ?-->/g, "");
    fs.readFile(folder + "blog/posts.json", function (_, data) {
        let json = JSON.parse(data);
        for (let i = 0; i < json.length; i++) {
            let post = json[i];
            fs.readFile(folder + "blog/" + post.id + ".md", function (_, content) {
                let dom = new JSDOM(template);
                var document = dom.window.document;

                document.title += " - " + post.name;
                document.querySelector('meta[property="og:title"]').setAttribute("content", post.name);
                document.querySelector('meta[name="description"]').setAttribute("content", post.summary);
                document.querySelector('meta[property="og:description"]').setAttribute("content", post.summary);

                var nav = "";
                nav += '<a class="nav-item nav-link" href="/#blog">Back to Main Page</a>';
                let last = getAdjacentPost(json, i, -1);
                if (last)
                    nav += '<a class="nav-item nav-link" href="/blog-' + last.id + '">Previous Post</a>';
                let next = getAdjacentPost(json, i, 1);
                if (next)
                    nav += '<a class="nav-item nav-link" href="/blog-' + next.id + '">Next Post</a>';
                document.getElementById("nav-items").innerHTML = nav;

                var c = "";
                c += '<div class="list-display rounded">';
                c += '<div class="blog-isolated">'
                c += '<h1>' + post.name + '</h1>';
                c += '<div id="blog-post-' + post.id + '">'
                if (post.archived)
                    c += "<p><i>This post has been archived.</i></p>"
                c += converter.makeHtml(content.toString());
                c += '</div>';
                c += '<span class="text-muted project-status blog-isolated-status">' + post.date + "</span>";
                if (post.discuss)
                    c += '<a href="' + post.discuss + '" class="blog-discuss" id="blog-discuss-' + post.id + '">Discuss this post</a>'
                c += '</div></div>';
                document.getElementById("main").innerHTML = c;

                let html = dom.serialize();
                fs.writeFile(folder + "blog-" + post.id + ".html", html, function (_, _) {});
            });
        }
    });
});

function getAdjacentPost(json, index, move) {
    while (true) {
        index += move;
        let post = json[index];
        if (!post)
            break;
        if (!post.archived)
            return post;
    }
}