const facts = [
    "For the longest time, I thought bitbucket was called 'gitbucket', and I didn't realize even when actually going to the site.",
    "There are a couple of secrets and easter eggs on this site, including the fact that this fact is randomized.",
    "I really like writing poems and stories, but I get burned out pretty fast and so I almost never finish anything.",
    "I wrote a book once, but I took all the links to it down because no one was buying it and it felt a bit embarrassing.",
    "I'm pretty flexible.",
    "I have pretty bad social anxiety, and I'm seeing a therapist and taking medication.",
    "A lot of times, I say that things are facts despite knowing that they're just opinions, and I hate myself for it.",
    "When I code in JavaScript, I randomly switch between using single and double quotes for strings, and it turns into a bit of a mess to look at.",
    "Sometimes, I get addicted to energy drinks for a while and have a terrible week while trying to stop drinking them so much.",
    "I only drink alcohol when I'm with my friends.",
    "I don't understand people who shower in the evening. Why would you want to wake up with all of the bed sweat on you and do nothing about it?",
    "I use document.write() despite the fact that Chrome tells me to stop every time I open the console on this site. Try me, Chrome.",
    "I'm actually not that good of a programmer.",
    "I like hugs.",
    "I get super nostalgic about the The Sims build mode songs. Those bring me back to my childhood, man.",
    "I love cheesy romcoms.",
    "I have a love-hate relationship with German pop music; sometimes I listen to it for days on end, other times I can't bear to hear it.",
    "According to 16personalities.com, which uses a modified version of the Myers–Briggs Type Indicator, I'm INFP-T.",
    "I love carrot cake."
];

const questions = [{
        q: 'How old are you?',
        a: "I'm " + getAge() + " years old. This automatically updates now, too, so I won't ever forget to update it again!"
    },
    {
        q: 'Where are you from?',
        a: "I am from Neuss, Germany and I'm currently living and going to university in Aachen, Germany."
    },
    {
        q: 'Why are you called Ellpeck?',
        a: "Well, it actually isn't as interesting of a story as some of you might hope. Long story short, when I was little (and was, apparently, very bad at English), I decided to make a YouTube channel called \"LetsPlayEveryGames.\" Shortly after, I also made a Minecraft account that I was going to call the same thing. At the time, though, there was a limit for how many characters your name could have, and so I opted for calling myself \"LPEG\" instead. When a friend of mine came along and started trying to pronounce that name, instead of saying each individual letter on its own, he started pronouncing it like a word: Ell-Peg. ...Ellpeck. I liked that pronounciation and so I stuck with the name."
    },
    {
        q: 'What languages do you speak?',
        a: 'I speak German, English, Java and C# fluently. I\'m okay at JavaScript and Python, and I can just about write something in C, HTML and CSS.'
    },
    {
        q: "How do you make games?",
        a: "I usually use the .NET-based framework <a href=\"http://www.monogame.net/\">MonoGame</a> together with some libraries to make it a bit easier, including my own library, MLEM, which you can read about in the <a href=\"#projects\">Projects</a> section."
    },
    {
        q: "What's your job/occupation?",
        a: "I'm currently studying Computer Science at the <a href=\"https://www.rwth-aachen.de/\">RWTH Aachen</a>. I don't have a job on the side or anything, though."
    },
    {
        q: 'Are you for hire?',
        a: 'You can commission me to make a Minecraft mod for you. You can find more information <a href="#commissions">here</a>.'
    },
    {
        q: 'What do you use to code?',
        a: "For Java, I use IntelliJ IDEA. For C#, I use JetBrains Rider. For most of my other projects, which are usually rather small, I use Visual Studio Code, which is awesome, by the way."
    },
    {
        q: 'How did you make this site?',
        a: 'I made this page using <a href="https://getbootstrap.com/">Bootstrap</a>. The content is dynamically generated using JavaScript (both on the client and the server) based on a bunch of JSON data. The code is over two years old and pretty messy, but you can look at it on the <a href="https://github.com/Ellpeck/Web">GitHub repository</a>.'
    },
    {
        q: 'What\'s your favorite programming language?',
        a: 'C#. It has everything that I wish Java had, and a lot more.'
    },
    {
        q: "What are your pronouns?",
        a: "I'm cis male, so I go by he/him."
    },
    {
        q: 'What\'s a random fact about you?',
        a: facts[Math.floor(Math.random() * facts.length)]
    }
];

let a = '';
for (question of questions) {
    a += '<p>';
    a += '<strong>Q: ' + question.q + '</strong><br>';
    a += '<strong>A:</strong> ' + question.a;
    a += '</p>';
}
$('#about-list').html(a);

function getAge() {
    let birthdayMillis = Date.UTC(1999, 4, 21);
    let todayMillis = Date.now();
    let ageSinceStart = new Date(todayMillis - birthdayMillis);
    return ageSinceStart.getUTCFullYear() - 1970;
}