const projects = [{
        name: 'Touchy Tickets',
        desc: "Touchy Tickets is a fun idle game for Android that has you selling tickets with various theme park attractions. It'll probably be released for iOS at some point, too.",
        links: {
            'Google Play': "https://play.google.com/store/apps/details?id=de.ellpeck.touchytickets"
        },
        status: "In development",
        icon: 'tt'
    },
    {
        name: 'Actually Additions',
        desc: 'Actually Additions is a rather popular Minecraft mod that I used to work on. It\'s become widely known in the modding community and has reached over 30 million downloads by now, which is crazy. I don\'t work on it anymore myself, but it\'s being maintained for current versions by someone else.',
        links: {
            'CurseForge page': 'https://www.ellpeck.de/actadd',
            'Online manual': 'https://www.ellpeck.de/actaddmanual/'
        },
        status: 'Maintained',
        icon: 'aa'
    },
    {
        name: "Nature's Aura",
        desc: "Nature's Aura is a Minecraft mod about collecting, using and replenishing the Aura naturally present in the world to create useful devices and unique mechanics.",
        status: 'In development',
        links: {
            'CurseForge page': 'https://minecraft.curseforge.com/projects/natures-aura'
        },
        icon: 'na'
    },
    {
        name: "Pretty Pipes",
        desc: "Pretty Pipes is a simple to use, all-inclusive item transport mod for Minecraft. It features simple pipes that can be upgraded using modules to accomplish much more advanced tasks.",
        status: 'In development',
        links: {
            'CurseForge page': 'https://www.curseforge.com/minecraft/mc-mods/pretty-pipes'
        },
        icon: 'pp'
    },
    {
        name: "MLEM",
        desc: "MLEM Library by Ellpeck for MonoGame is an addition to the game framework <a href=\"http://www.monogame.net/\">MonoGame</a> that provides extension methods, quality of life improvements and additional features like a Ui system and easy input handling.",
        links: {
            "Get it on NuGet": "https://www.nuget.org/packages?q=mlem",
            "See the website": "https://mlem.ellpeck.de/"
        },
        status: "Side project",
        icon: "mlem"
    },
    {
        name: "Foe Frenzy",
        desc: "Foe Frenzy is a fast-paced fighting game where you battle up to three of your friends with random, short-lasting items in an attempt to be the last survivor.",
        links: {
            "Check it out": "/foefrenzy"
        },
        status: "Released",
        icon: "ff"
    }
];

let p = '';
for (project of projects) {
    p += '<div class="card bg-light project rounded-0">';
    p += '<div class="card-body">';
    p += '<img class="project-image" src="res/projects/' + project.icon + '.png" alt="">';

    p += '<h4 class="card-title">' + project.name + '</h4>';
    p += '<p class="card-text">' + project.desc + '</p>';
    if (project.status)
        p += '<span class="text-muted project-status">' + project.status + '</span>';

    if (project.links) {
        for (let name in project.links) {
            p += '<a href="' + project.links[name] + '" class="card-link btn ' + (dark ? "btn-outline-light" : "btn-outline-info") + ' rounded-0">' + name + '</a>';
        }
    }

    p += '</div>';
    p += '</div>';
}
$('#project-list').html(p);